=== debian/changelog ===
ocamlbuild (0.16.1-2build1) resolute; urgency=medium

  * Rebuild against new OCAML ABIs.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sun, 28 Dec 2025 22:04:18 +0100

ocamlbuild (0.16.1-2) unstable; urgency=medium

  * Team upload
  * Fix PrincipalFlag test with OCaml 5.4.0
  * Bump Standards-Version to 4.7.2
  * Remove Rules-Requires-Root

 -- Stéphane Glondu <glondu@debian.org>  Wed, 17 Dec 2025 14:01:23 +0100

ocamlbuild (0.16.1-1) unstable; urgency=medium

  * New upstream release

 -- Stéphane Glondu <glondu@debian.org>  Sat, 08 Mar 2025 08:26:00 +0100
